#ifndef _FILTERING_H_
#define _FILTERING_H_

#include "cimage.h"
#include "adjacency.h"

typedef struct _kernel {
  float *val;
  AdjRel *adj;
  int xsize,ysize;
} Kernel;

/* Funes dadas */

Kernel *MakeKernel(char *coefs); /* Cria e inicializa kernel a partir
                                    de cadeia de coeficientes */
Kernel *CreateKernel(AdjRel *A); /* Cria kernel sem coeficientes */
void    DestroyKernel(Kernel **K); /* Destri kernel */

/* Questo 5a (1,5): Aplique filtragem linear na banda de luminncia
   apenas, e retorne a imagem colorida filtrada. */

CImage  *CLinearFilter1(CImage *cimg, Kernel *K);

/* Questo 5b (1,5): Aplique filtragem linear em todas as bandas, e
   retorne a imagem colorida filtrada. */

CImage  *CLinearFilter2(CImage *cimg, Kernel *K);


#endif
