#ifndef _IMAGE_H_
#define _IMAGE_H_

#include "common.h"

typedef struct _pixel {
  int x,y;
} Pixel;

typedef struct _image {
  int *val;
  int ncols,nrows;
  int *tbrow;
} Image;

/* Funes dadas */

Image  *CreateImage(int ncols,int nrows); /* Cria uma imagem com zeros */
void    DestroyImage(Image **img); /* Destri a imagem */
Image  *ReadImage(char *filename); /* L P2 e P5 */
void    WriteImage(Image *img, char *filename); /* Escreve P2 ou P5 */
int     MinimumValue(Image *img); /* Calcula o valor mnimo na imagem */
int     MaximumValue(Image *img); /* Calcula o valor mximo na imagem */
bool    ValidPixel(Image *img, int x, int y); /* Verifica se o pixel
                                                 est no domnio da
                                                 imagem */
Image  *CopyImage(Image *img); /* Faz uma cpia da imagem */

#endif





