#include "adjacency.h"

AdjRel *CreateAdjRel(int n)
{
  AdjRel *A=NULL;

  A = (AdjRel *) calloc(1,sizeof(AdjRel));
  if (A != NULL){
    A->dx = AllocIntArray(n);
    A->dy = AllocIntArray(n);
    A->n  = n;
  } else {
    Error(MSG1,"CreateAdjRel");
  }

  return(A);
}

void DestroyAdjRel(AdjRel **A)
{
  AdjRel *aux;

  aux = *A;
  if (aux != NULL){
    if (aux->dx != NULL) free(aux->dx);
    if (aux->dy != NULL) free(aux->dy);
    free(aux);
    *A = NULL;
  }   
}

AdjRel *Box(int ncols, int nrows)
{
  AdjRel *A=NULL;
  int i,dx,dy;

  if (ncols%2 == 0) ncols++;
  if (nrows%2 == 0) nrows++;

  A = CreateAdjRel(ncols*nrows);
  i=1;
  for(dy=-nrows/2;dy<=nrows/2;dy++){
    for(dx=-ncols/2;dx<=ncols/2;dx++){
      if ((dx != 0)||(dy != 0)){
	A->dx[i]=dx;
	A->dy[i]=dy;
	i++;
      }
    }
  }
  /* place the central pixel at first */
  A->dx[0] = 0;
  A->dy[0] = 0;

  return(A);
}
