#include "filtering.h"

/* Questo 5a (1,5): Aplique filtragem linear na banda de luminncia
   apenas, e retorne a imagem colorida filtrada. */

CImage  *CLinearFilter1(CImage *cimg, Kernel *K)
{
  CImage *cfil=NULL;


  return(cfil);
}

/* Questo 5b (1,5): Aplique filtragem linear em todas as bandas, e
   retorne a imagem colorida filtrada. */

CImage  *CLinearFilter2(CImage *cimg, Kernel *K)
{
  CImage *cfil=NULL;

  return(cfil);
}


Kernel *MakeKernel(char *coefs)
{
  Kernel *K;
  AdjRel *A;
  int xsize,ysize,i;
  float val;

  sscanf(coefs,"%d",&xsize);
  coefs=strchr(coefs,',')+1;
  sscanf(coefs,"%d",&ysize);
  coefs=strchr(coefs,',')+1;

  A = Box(xsize, ysize);
  K = CreateKernel(A);
  for (i=0;i<A->n;i++) {
    sscanf(coefs,"%f",&K->val[i]);
    coefs=strchr(coefs,',')+1;
  }

  /* Put the middle value (corresponding to the origin) at the first
     place to match the vector of coefficients with the vector of
     displacements (adjacency relation) */

  for (i=A->n/2; i > 0; i--){
    val = K->val[i];
    K->val[i]=K->val[i-1];
    K->val[i-1]=val;
  }

  DestroyAdjRel(&A);
  return(K);
}

Kernel *CreateKernel(AdjRel *A)
{
  Kernel *K=NULL;
  int i;
  Pixel max, min;

  max.x = max.y = INT_MIN;
  min.x = min.y = INT_MAX;

  K = (Kernel *) calloc(1,sizeof(Kernel));
  if (K == NULL){
    Error(MSG1,"CreateKernel");
  }
  K->val = AllocFloatArray(A->n);
  K->adj = CreateAdjRel(A->n);

  for (i=0;i<A->n;i++) {
    max.x = MAX(A->dx[i],max.x);
    max.y = MAX(A->dy[i],max.y);
    min.x = MIN(A->dx[i],min.x);
    min.y = MIN(A->dy[i],min.y);
    K->adj->dx[i] = A->dx[i];
    K->adj->dy[i] = A->dy[i];
  }
  
  K->xsize = max.x - min.x + 1;
  K->ysize = max.y - min.y + 1;
  
  return(K);
}

void DestroyKernel(Kernel **K)
{
  Kernel *aux;

  aux = *K;
  if(aux != NULL){
    if (aux->val != NULL)   free(aux->val); 
    DestroyAdjRel(&(aux->adj));
    free(aux);    
    *K = NULL;
  }
}


