#ifndef _IMAGE_H_
#define _IMAGE_H_

#include "common.h"

typedef struct _pixel {
  int x,y;
} Pixel;

typedef struct _image {
  int *val;
  int ncols,nrows;
  int *tbrow;
} Image;

Image  *CreateImage(int ncols,int nrows);
void    DestroyImage(Image **img);
Image  *ReadImage(char *filename);
void    WriteImage(Image *img, char *filename);
int     MinimumValue(Image *img);
int     MaximumValue(Image *img);
bool    ValidPixel(Image *img, int x, int y);
Image  *CopyImage(Image *img);
Image  *Sum(Image *img1, Image *img2);
Image  *CreateCos(int ncols, int nrows, float wx, float wy, float phix, float phiy);
Image  *CreateSquare(int xo, int yo, int xf, int yf, int ncols, int nrows, int val);
Image  *CreateIntArray(char *data);

/* Funes da questo 1 */

Image *AddZeros(Image *img, int Nx, int Ny); /* Crie uma nova imagem
                                                com Nx zeros  direita
                                                e Ny zeros  baixo da
                                                imagem original */

Image *RemZeros(Image *img, int Nx, int Ny); /* Crie uma nova imagem
						com menos Nx zeros da
						direita para esquerda
						e menos Ny zeros de
						baixo para cima */

#endif





