#ifndef _MORPHOLOGY_H_
#define _MORPHOLOGY_H_

#include "seeds.h"

Image  *Dilate(Image *img, AdjRel *A);
Image  *Erode(Image *img, AdjRel *A);
Image  *Close(Image *img, AdjRel *A);
Image  *Open(Image *img, AdjRel *A);
Image  *MorphGrad(Image *img, AdjRel *A);

/*--------------------------------------------------------------------*/
/* Funcoes da questao 1 (2,0): Use IFTFIFO para implementar os filtros
   por reconstrucao abaixo em alto nivel. Use CopyImage em image.c
   para copiar o conteudo desejado da imagem anotada. Esta observacao
   vale para todas as funcoes do projeto que criam internamente
   imagens anotadas. */

Image *CloseRec(Image *img, AdjRel *A); /* Calcule o fechamento de img
					   com adjacencia A para gerar
					   a imagem marcadora, depois
					   calcule a reconstrucao
					   superior de img a partir da
					   imagem marcadora usando
					   adjacencia circular de raio
					   1 (Vizinhanca-4). */

Image *OpenRec(Image *img, AdjRel *A); /* Dual de CloseRec. Crie a
                                          funcao dual Finfrec em
                                          genift.h e genift.c para
                                          realizar esta operacao em
                                          imagens de 8-bits. Use
                                          Complement em image.c para
                                          calcular o complemento de
                                          uma imagem. */

Image *CloseBasins(Image *img); /* Calcule o fechamento de bacias (ou
                                   buracos, no caso de imagens
                                   binarias). Use LambdaFrame em
                                   seeds.c para definir sementes e
                                   adjacencia-4. */

Image *OpenDomes(Image *img);   /* Dual de CloseBasins para imagens de
                                   8-bits. Use Finfrec. */

/*--------------------------------------------------------------------*/
/* Funcoes da questao 2 (2,0): Copie IFTFIFO e modifique-a para que os
filtros por reconstrucao abaixo so calculem a informacao necessaria e
o mais rapido possivel. Nao use imagem anotada e nenhuma funcao de
genift.c. Use adjacencia-4 em todas as funcoes abaixo. */

void SupRec(Image *mask, Image *marker); /* Calcule a reconstrucao
                                            superior de mask a partir
                                            de marker, assumindo que
                                            marker > mask, e retorne o
                                            resultado em
                                            marker. Assuma todos os
                                            pixels como sementes
                                            independente do valor em
                                            marker. */

void LocalSupRec(Image *mask, Image *marker); /* Calcule a
                                              reconstrucao superior
                                              local de mask a partir
                                              de marker, e retorne o
                                              resultado em
                                              marker. Assuma neste
                                              caso que marker > mask
                                              eh um marcador binario,
                                              com valor INT_MAX quando
                                              o pixel nao for
                                              semente. */

#endif
