#ifndef _SEGMENTATION_H_
#define _SEGMENTATION_H_

#include "seeds.h"

/*--------------------------------------------------------------------*/
/* Funcoes da questao 3 (3,0): Copie IFTFIFO e modifique-a para que as
transformadas de watershed abaixo so calculem a informacao necessaria
e o mais rapido possivel. Nao use nenhuma funcao de genift.c e adote
adjacencia-8. */

void WaterLabel(Image *img, Image *label); /* Calcule a transformada
			  de watershed de img com imposicao de
			  marcadores (handicap=0), usando como
			  sementes os pixels cujo label >= 0. Retorne
			  em label a imagem das bacias rotuladas. */

void LocalWaterRec(Image *mask, Image *marker, Image *label); /*
                              Repita a questao anterior usando como
                              sementes pixels com label >= 0, a
                              reconstrucao superior local e retornando
                              em label a imagem das bacias
                              rotuladas.*/

void WaterThres(Image *mask, Image *label, int thres); /* 
			      Calcule a transformada de watershed de
			      mask com imposicao de marcadores, usando
			      como marcadores os pixels com label >= 0
			      e um limiar thres de saturacao para a
			      funcao de custo.  Isto eh, a funcao de
			      custo retorna custo INT_MAX se o custo
			      da reconstrucao superior for maior que
			      thres. Retorne em label a imagem das
			      bacias rotuladas. */

/*--------------------------------------------------------------------*/
/* Funcoes da questao 4 (3,0): Copie IFTFIFO e modifique-a para que as
funcoes de perseguicao de borda abaixo so calculem a informacao
necessaria e o mais rapido possivel. Nao use nenhuma funcao de
genift.c e adote adjacencia-8. */

Image *FindEdge(Image *img, Image *label); /* Assuma que os pixels com
                                              rotulo 1 em label sao os
                                              pontos de partida e que
                                              os pixels com rotulo 2
                                              em label sao os pontos
                                              de chegada. Calcule o
                                              caminho de custo minimo
                                              do conjunto de partida
                                              para o de chegada. O
                                              criterio de parada eh
                                              quando o caminho otimo
                                              encontra o primeiro
                                              pixel do conjunto de
                                              chegada. Use Fctrack
                                              embutida no seu
                                              algoritmo. Retorne o
                                              mapa de
                                              predecessores. */

AnnImg *FindSegm(Image *img, Image *handicap, Image *lambda, int iter); /*
                                              Assuma que os pixels com
                                              rotulo iter em lambda
                                              sao os pontos de partida
                                              com um certo custo de
                                              handicap e que os pixels
                                              com rotulo iter+1 em
                                              lambda sao os pontos de
                                              chegada. Calcule uma IFT
                                              do conjunto de partida
                                              para o de chegada usando
                                              como criterio de parada
                                              quando o caminho otimo
                                              encontra o ultimo pixel
                                              do conjunto de
                                              chegada. Use Fctrack
                                              embutida no seu
                                              algoritmo. Retorne a
                                              imagem anotada. */

Image *FindContour(Image *img, Image *lambda); /* Assuma que os pixels
                                              com rotulo i=1,2,etc. em
                                              lambda sao os pontos de
                                              partida de cada iteracao
                                              da IFT usando FindSegm e
                                              que os pixels com rotulo
                                              i+1 em lambda sao os
                                              pontos de
                                              chegada. Calcule o
                                              contorno otimo que passa
                                              por esses pontos usando
                                              as informacoes dos mapas
                                              de predecessores das
                                              iteracoes. Use Fctrack
                                              embutida no seu
                                              algoritmo. Retorne uma
                                              imagem binaria com valor
                                              255 se o pixel pertence
                                              ao contorno e 0 no caso
                                              contrario. Observe que
                                              FindEdge deve ser usado
                                              no final para ligar o
                                              ultimo e o primeiro
                                              ponto do contorno que
                                              pertencem a marca de
                                              rotulo 1, mas que podem
                                              ser pontos
                                              diferentes. */
#endif
