#include "gift.h"

int main(int argc, char **argv)
{
  timer tic,toc;
  FILE *ftime=fopen("time.txt","w");
  AdjRel *A=NULL;
  Image *img;
  Image *aux1,*aux2;

  /* The following block must the remarked when using non-linux machines 

  void *trash = malloc(1);                 
  struct mallinfo info;   
  int MemDinInicial, MemDinFinal;
  free(trash); 
  info = mallinfo();
  MemDinInicial = info.uordblks;
  */
  
  /* Fechamento por reconstrucao usando SupRec. O resultado deve ser
     identico a questao1_a.pgm. */

  img      = ReadImage("../data/vessels.pgm");  
  A        = Circular(5.0);
  gettimeofday(&tic,NULL);  
  aux1     = Close(img,A);
  SupRec(img,aux1);
  gettimeofday(&toc,NULL);
  fprintf(ftime,"Close and SupRec in %f milliseconds\n",(toc.tv_sec-tic.tv_sec)*1000.0 + (toc.tv_usec-tic.tv_usec)*0.001);
  aux2     = Diff(aux1,img);
  WriteImage(aux2,"questao2_a.pgm");
  DestroyImage(&aux1);
  DestroyImage(&aux2);
  DestroyAdjRel(&A);
   
  /* Fechamento de bacia usando LocalSupRec */

  aux1 = CreateImage(img->ncols,img->nrows);
  SetImage(aux1,INT_MAX);
  aux1->val[80+aux1->tbrow[91]]=50;
  gettimeofday(&tic,NULL);  
  LocalSupRec(img,aux1);
  gettimeofday(&toc,NULL);
  fprintf(ftime,"LocalSupRec in %f milliseconds\n",(toc.tv_sec-tic.tv_sec)*1000.0 + (toc.tv_usec-tic.tv_usec)*0.001);
  aux2     = Diff(aux1,img);
  WriteImage(aux2,"questao2_b.pgm");
  DestroyImage(&aux1);
  DestroyImage(&aux2);
  DestroyImage(&img);

  /* Fechamento de bacia usando LocalSupRec */

  img  = ReadImage("../data/carcinoma.pgm");  
  aux1 = CreateImage(img->ncols,img->nrows);
  SetImage(aux1,INT_MAX);
  aux1->val[119+aux1->tbrow[116]]=30;
  gettimeofday(&tic,NULL);  
  LocalSupRec(img,aux1);
  gettimeofday(&toc,NULL);
  fprintf(ftime,"LocalSupRec in %f milliseconds\n",(toc.tv_sec-tic.tv_sec)*1000.0 + (toc.tv_usec-tic.tv_usec)*0.001);
  aux2     = Diff(aux1,img);
  WriteImage(aux2,"questao2_c.pgm");
  DestroyImage(&aux1);
  DestroyImage(&aux2);
  DestroyImage(&img);

  /* The following block must the remarked when using non-linux machines 

  info = mallinfo();
  MemDinFinal = info.uordblks;
  if (MemDinInicial!=MemDinFinal)
    printf("\n\nDinamic memory was not completely deallocated (%d, %d)\n",
	   MemDinInicial,MemDinFinal);   
  */

  fclose(ftime);

  return(0);
}
