#include "gift.h"

int main(int argc, char **argv)
{
  timer tic,toc;
  FILE *ftime=fopen("time.txt","w");
  AdjRel *A=NULL,*A5=Circular(5.0);
  Image *img,*lambda;
  Image *aux1,*aux2,*pred,*cont;
  int p,q,i;
  Pixel u,v;

  /* The following block must the remarked when using non-linux machines 

  void *trash = malloc(1);                 
  struct mallinfo info;   
  int MemDinInicial, MemDinFinal;
  free(trash); 
  info = mallinfo();
  MemDinInicial = info.uordblks;
  */
  /* Image preparation for contour tracking */

  aux1     = ReadImage("../data/caudate.pgm");  
  aux2     = CopyImage(aux1);
  A        = Circular(1.5);  
  img      = GaussStretch(aux1,140.0,30.0);
  lambda   = CreateImage(img->ncols,img->nrows);

  /* Find segment from (67,68) to (16,20) */

  SetLambda(lambda,67,68,1);
  SetLambda(lambda,16,20,2);
  gettimeofday(&tic,NULL);  
  pred=FindEdge(img,lambda);
  gettimeofday(&toc,NULL);
  fprintf(ftime,"FindEdge in %f milliseconds\n",(toc.tv_sec-tic.tv_sec)*1000.0 + (toc.tv_usec-tic.tv_usec)*0.001);

  DrawPath(aux2,pred,16+img->tbrow[20],255);
  WriteImage(aux2,"questao4_a.pgm");

  /* Find contour from/to neighbors of (67,68) passing through
     neighbors of (16,20) */

  DestroyImage(&aux1);
  DestroyImage(&aux2);  
  DestroyImage(&pred);
  aux2 = ReadImage("../data/caudate.pgm");  

  u.x = 67;
  u.y = 68;
  //DrawPoint(aux2,u.x,u.y,5.0,255);
  p   = u.x + lambda->tbrow[u.y];
  for (i=1; i < A5->n; i++) {
    v.x = u.x + A5->dx[i];
    v.y = u.y + A5->dy[i];
    if (ValidPixel(lambda,v.x,v.y)){
      q = v.x + lambda->tbrow[v.y];
      lambda->val[q]=lambda->val[p];
    }
  }
  u.x = 16;
  u.y = 20;
  //DrawPoint(aux2,u.x,u.y,5.0,255);
  p   = u.x + lambda->tbrow[u.y];
  for (i=1; i < A5->n; i++) {
    v.x = u.x + A5->dx[i];
    v.y = u.y + A5->dy[i];
    if (ValidPixel(lambda,v.x,v.y)){
      q = v.x + lambda->tbrow[v.y];
      lambda->val[q]=lambda->val[p];
    }
  }

  gettimeofday(&tic,NULL);  
  cont=FindContour(img,lambda);
  gettimeofday(&toc,NULL);
  fprintf(ftime,"FindContour in %f milliseconds\n",(toc.tv_sec-tic.tv_sec)*1000.0 + (toc.tv_usec-tic.tv_usec)*0.001);

  aux1 = Or(aux2,cont);
  WriteImage(aux1,"questao4_b.pgm");

  /* Find contour passing through neighbors of
     (271,51);(22,83);(64,140);(163,109);(286,120) */

  DestroyImage(&aux1);
  DestroyImage(&aux2);  
  DestroyImage(&pred);
  DestroyImage(&lambda);
  DestroyImage(&img);
  DestroyImage(&cont);
  aux1     = ReadImage("../data/cerebellum.pgm");  
  aux2     = CopyImage(aux1);
  img      = GaussStretch(aux1,60.0,30.0);
  lambda   = CreateImage(img->ncols,img->nrows);
  
  u.x = 271;
  u.y = 51;
  //DrawPoint(aux2,u.x,u.y,5.0,255);
  SetLambda(lambda,u.x,u.y,1);
  p   = u.x + lambda->tbrow[u.y];
  for (i=1; i < A5->n; i++) {
    v.x = u.x + A5->dx[i];
    v.y = u.y + A5->dy[i];
    if (ValidPixel(lambda,v.x,v.y)){
      q = v.x + lambda->tbrow[v.y];
      lambda->val[q]=lambda->val[p];
    }
  }
  u.x = 22;
  u.y = 83;
  //DrawPoint(aux2,u.x,u.y,5.0,255);
  SetLambda(lambda,u.x,u.y,2);
  p   = u.x + lambda->tbrow[u.y];
  for (i=1; i < A5->n; i++) {
    v.x = u.x + A5->dx[i];
    v.y = u.y + A5->dy[i];
    if (ValidPixel(lambda,v.x,v.y)){
      q = v.x + lambda->tbrow[v.y];
      lambda->val[q]=lambda->val[p];
    }
  }
  u.x = 64;
  u.y = 140;
  //DrawPoint(aux2,u.x,u.y,5.0,255);
  SetLambda(lambda,u.x,u.y,3);
  p   = u.x + lambda->tbrow[u.y];
  for (i=1; i < A5->n; i++) {
    v.x = u.x + A5->dx[i];
    v.y = u.y + A5->dy[i];
    if (ValidPixel(lambda,v.x,v.y)){
      q = v.x + lambda->tbrow[v.y];
      lambda->val[q]=lambda->val[p];
    }
  }
  u.x = 163;
  u.y = 109;
  //DrawPoint(aux2,u.x,u.y,5.0,255);
  SetLambda(lambda,u.x,u.y,4);
  p   = u.x + lambda->tbrow[u.y];
  for (i=1; i < A5->n; i++) {
    v.x = u.x + A5->dx[i];
    v.y = u.y + A5->dy[i];
    if (ValidPixel(lambda,v.x,v.y)){
      q = v.x + lambda->tbrow[v.y];
      lambda->val[q]=lambda->val[p];
    }
  }
  u.x = 286;
  u.y = 120;
  //DrawPoint(aux2,u.x,u.y,5.0,255);
  SetLambda(lambda,u.x,u.y,5);
  p   = u.x + lambda->tbrow[u.y];
  for (i=1; i < A5->n; i++) {
    v.x = u.x + A5->dx[i];
    v.y = u.y + A5->dy[i];
    if (ValidPixel(lambda,v.x,v.y)){
      q = v.x + lambda->tbrow[v.y];
      lambda->val[q]=lambda->val[p];
    }
  }

  gettimeofday(&tic,NULL);  
  cont=FindContour(img,lambda);
  gettimeofday(&toc,NULL);
  fprintf(ftime,"FindContour in %f milliseconds\n",(toc.tv_sec-tic.tv_sec)*1000.0 + (toc.tv_usec-tic.tv_usec)*0.001);

  aux1 = Or(aux2,cont);
  WriteImage(aux1,"questao4_c.pgm");


  DestroyImage(&img);
  DestroyImage(&lambda);
  DestroyAdjRel(&A);
  DestroyImage(&aux1);
  DestroyImage(&aux2);
  DestroyImage(&pred);
  DestroyImage(&cont);
  DestroyAdjRel(&A5);

  /* The following block must the remarked when using non-linux machines 

  info = mallinfo();
  MemDinFinal = info.uordblks;
  if (MemDinInicial!=MemDinFinal)
    printf("\n\nDinamic memory was not completely deallocated (%d, %d)\n",
	   MemDinInicial,MemDinFinal);   
  */

  fclose(ftime);

  return(0);
}
